#include "string.h"
#include "stdlib.h"

#include "SDL.h"
#include "SDL_net.h"
#include "SDL_ttf.h"

#include "BList.h"
#include "auxiliar.h"

#include "variables.h"
#include "mog2.h"
#include "object.h"
#include "tiles.h"
#include "mog2multiplayer.h"
#include "interfaces.h"

#include "BWindow.h"
#include "BActiveWindow.h"
#include "BStringEdDlg.h"
#include "BIntegerEdDlg.h"
#include "BChoiceDlg.h"
#include "BVChoiceDlg.h"
#include "BListWnd.h"
#include "BMultiListWnd.h"

#include "GrabGrabberWnd.h"
#include "GrabToolsWnd.h"

#include "GamePReviewDlg.h"
#include "RMoveDlg.h"
#include "BPlaneSelectionDlg.h"
#include "ParallaxWnd.h"

#include "editor.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

GrabToolsWnd::GrabToolsWnd(int x,int y,int dx,int dy,EDITOR *e,TTF_Font *font) : BWindow(x,y,dx,dy,font) 
{
	BButton *b;
	editor=e;

	b=new BButton(160,0,100,12,"GRID",1);
	buttons.Add(b);

	b=new BButton(360,0,100,12,"CUSTOM",2);
	buttons.Add(b);

} /* GrabToolsWnd::GrabToolsWnd */ 


GrabToolsWnd::~GrabToolsWnd()
{
} /* RToolsWnd::~RToolsWnd */ 


bool GrabToolsWnd::cycle(int stx,int sty)
{
	BWindow::cycle(stx,sty);


	return true;
} /* GrabToolsWnd::cycle */ 


void GrabToolsWnd::contens_size(int *dx,int *dy)
{
	BWindow::contens_size(dx,dy);
} /* GrabToolsWnd::contens_size */ 


void GrabToolsWnd::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	SDL_FillRect(sfc,0,0);

	BWindow::draw_contens(sfc,stx,sty,dx,dy);

	if (editor->grabv_bitmap!=0) {
		char tmp[80];

		if (editor->grabv_grid==-1) {
			sprintf(tmp,"%ix%i",editor->grabv_grid_x,editor->grabv_grid_y);
			print_left(tmp,font,255,255,255,sfc,270-stx,4-sty);
		} /* if */ 
		if (editor->grabv_grid==0) print_left("1x1",font,255,255,255,sfc,270-stx,4-sty);
		if (editor->grabv_grid==1) print_left("2x2",font,255,255,255,sfc,270-stx,4-sty);
		if (editor->grabv_grid==2) print_left("4x4",font,255,255,255,sfc,270-stx,4-sty);
		if (editor->grabv_grid==3) print_left("8x8",font,255,255,255,sfc,270-stx,4-sty);
		if (editor->grabv_grid==4) print_left("16x16",font,255,255,255,sfc,270-stx,4-sty);
		if (editor->grabv_grid==5) print_left("32x32",font,255,255,255,sfc,270-stx,4-sty);

		if (editor->GrabGW->pointer_x>=0 && editor->GrabGW->pointer_x<=editor->grabv_bitmap->w &&
			editor->GrabGW->pointer_y>=0 && editor->GrabGW->pointer_y<=editor->grabv_bitmap->h) {

			sprintf(tmp,"X: %.4i Y:%.4i",editor->GrabGW->pointer_x,editor->GrabGW->pointer_y);
			print_left(tmp,font,255,255,255,sfc,4-stx,4-sty);
		} /* if */ 

	} /* if */ 


} /* RToolsWnd::draw_contens */ 


bool GrabToolsWnd::button_pressed(int ID)
{
	switch(ID) {
	case 1:
		/* Change GRID: */ 
		{
			editor->grabv_grid++;
			if (editor->grabv_grid>=6) editor->grabv_grid=0;
			set_dirty();
		}

		break;
	case 2:
		/* Custom GRID: */ 
		{
			BIntegerEdDlg *dlg;
			int y,x;

			new_window_coordinates(140,60,&x,&y);

			editor->grabv_grid_x=0;
			dlg=new BIntegerEdDlg(x,y,140,60,"X grid:",&editor->grabv_grid_x,3,font);
			dlg->Execute();
			delete dlg;

			new_window_coordinates(140,60,&x,&y);

			editor->grabv_grid_y=0;
			dlg=new BIntegerEdDlg(x,y,140,60,"Y grid:",&editor->grabv_grid_y,3,font);
			dlg->Execute();
			delete dlg;

			editor->grabv_grid=-1;
		}
	default:
		break;
	} /* switch */ 

	return false;
} /* GrabToolsWnd::button_pressed */ 
